#include <stdio.h>
#include <stdlib.h>



int da(int n1[], int l, int q){	
	
	int i, p = 0;
	

	
	for(i = l-1; i<q-1; i++){
		if(n1[i] > n1[i+1] && i != q-1){
				
			p++;	
			if(p>1) break;
	}
	
}
	

	
	if(p >1) return 0;
		else return 1;
	
}


int main(){
	
	int n, i, q;
	
	scanf("%d", &n);
	
	int n1[n], pk = 0;
	
	for(i = 0; i<n; i++){
		
		scanf("%d", &n1[i]);
		if(n1[i] == 1 || n1[i] == 2) pk++;
	}
	
	
	
	
	scanf("%d", &q);
	
	int l[n], t[n];
	int odg[n];
	int p = 0;
	if(pk == n) goto b;
	
	for(i = 0; i<q; i++){
		
		scanf("%d %d", &l[i], &t[i]);
		
		odg[p] = da(n1, l[i], t[i]);
		
		p++;
		
	}
		
	for(i = 0; i<p; i++){
		
		if(odg[i] == 1) printf("DA\n");
			else printf("NE\n");
		
	}
	goto a;
	b:
	for(i = 0;i<q; i++){
		printf("NE\n");
		
	}
	a:
	return 0;
}